#!/system/bin/sh

#============================================================#
# init.post_boot.sh script created for Android Revolution HD #
# by mike1986                                                #
# Do not try to remove this file from the system!            #
#============================================================#

# Kernel tweaks for MSN7x30 devices (HTC Desire HD, HTC Incredible S, HTC Inspire 4G)
target=`getprop ro.board.platform`
case "$target" in "msm7x30")
	echo "conservative" > /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor
	echo "300000" > /sys/devices/system/cpu/cpu0/cpufreq/conservative/sampling_rate
	echo "90" > /sys/devices/system/cpu/cpu0/cpufreq/conservative/up_threshold
	echo "ondemand" > /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor
	echo "10000" > /sys/devices/system/cpu/cpu0/cpufreq/ondemand/sampling_rate
	echo "60" > /sys/devices/system/cpu/cpu0/cpufreq/ondemand/up_threshold
	echo "30" > /sys/devices/system/cpu/cpufreq/ondemand/down_differential
	echo "vr" > /sys/block/mmcblk0/queue/scheduler
	echo "vr" > /sys/block/mmcblk1/queue/scheduler
;;

# Kernel tweaks for MSN8660 devices (HTC Sensation/4G/XE, HTC EVO 3D CDMA/GSM, HTC Amaze 4G)
"msm8660")
	#echo "90" > /sys/devices/system/cpu/cpufreq/conservative/up_threshold
	#echo "ondemand" > /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor
	#echo "ondemand" > /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor
	#echo "10000" > /sys/devices/system/cpu/cpufreq/ondemand/sampling_rate
	chgrp root /sys/devices/system/cpu/cpufreq/ondemand/sampling_rate
	chmod 664 /sys/devices/system/cpu/cpufreq/ondemand/sampling_rate
	#echo "60" > /sys/devices/system/cpu/cpufreq/ondemand/up_threshold
	echo "1" > /sys/devices/system/cpu/cpufreq/ondemand/io_is_busy
	#echo "2" > /sys/devices/system/cpu/cpufreq/ondemand/sampling_down_factor
	#echo "30" > /sys/devices/system/cpu/cpufreq/ondemand/down_differential
	#echo "384000" > /sys/devices/system/cpu/cpu0/cpufreq/scaling_min_freq
	#echo "384000" > /sys/devices/system/cpu/cpu1/cpufreq/scaling_min_freq
	chgrp root /sys/devices/system/cpu/cpu0/online
	chgrp root /sys/devices/system/cpu/cpu1/online
	#echo "cfq" > /sys/block/mmcblk0/queue/scheduler
	#echo "cfq" > /sys/block/mmcblk1/queue/scheduler

# Tweak IntelliDemand governor by faux123 (kernel must include this governor!)
# Then set back OnDemand as default governor
	#echo "intellidemand" > /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor
	#echo "intellidemand" > /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor
	#echo "10000" > /sys/devices/system/cpu/cpufreq/intellidemand/sampling_rate
	#chgrp root /sys/devices/system/cpu/cpufreq/intellidemand/sampling_rate
	#chmod 664 /sys/devices/system/cpu/cpufreq/intellidemand/sampling_rate
	#echo "60" > /sys/devices/system/cpu/cpufreq/intellidemand/up_threshold
	#echo "ondemand" > /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor
	#echo "ondemand" > /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor

# Enable ZRAM (kernel must support ZRAM feature!)
	mkswap /dev/block/zram0
	swapon /dev/block/zram0
;;

# Kernel tweaks for Asus Eee Pad Transformer (nVidia Tegra 2)
"tegra")
	echo "216000" > /sys/devices/system/cpu/cpu0/cpufreq/scaling_min_freq #(default=216000)
	echo "216000" > /sys/devices/system/cpu/cpu1/cpufreq/scaling_min_freq #(default=216000)
	echo "1000000" > /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq #(default=1000000)
	echo "1000000" > /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq #(default=1000000)
	echo "interactive" > /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor #(default=interactive)
	echo "interactive" > /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor #(default=interactive)
	echo "60" > /sys/devices/system/cpu/cpufreq/interactive/go_maxspeed_load #(default=80)
	echo "20000" > /sys/devices/system/cpu/cpufreq/interactive/min_sample_time #(default=80000)
	echo "deadline" > /sys/block/mmcblk0/queue/scheduler #(default=noop)
	echo "deadline" > /sys/block/mmcblk1/queue/scheduler #(default=noop)
;;

# Kernel tweaks for Samsung Galaxy Nexus (TI OMAP 4460)
"omap4")
	echo "interactive" > /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor #(default=interactive)
	echo "interactive" > /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor #(default=interactive)
	echo "20000" > /sys/devices/system/cpu/cpufreq/interactive/min_sample_time
	echo "10000" > /sys/devices/system/cpu/cpufreq/interactive/timer_rate
	echo "60" > /sys/devices/system/cpu/cpufreq/interactive/go_hispeed_load
	echo "920000" > /sys/devices/system/cpu/cpufreq/interactive/hispeed_freq
	echo "deadline" > /sys/block/mmcblk0/queue/scheduler
;;
esac

target=`getprop ro.ident`
case "$target" in "Android_Revolution_HD")
# Other kernel tweaks
	mount -t debugfs none /sys/kernel/debug
	echo "NO_NORMALIZED_SLEEPER" > /sys/kernel/debug/sched_features
	echo "NO_NEW_FAIR_SLEEPERS" > /sys/kernel/debug/sched_features
	umount /sys/kernel/debug
	echo "0" > /proc/sys/kernel/panic_on_oops
	echo "0" > /proc/sys/kernel/tainted

# Virtual Memory tweaks
	#echo "0" > /proc/sys/vm/swappiness #(default=60)
	#echo "70" > /proc/sys/vm/vfs_cache_pressure #(default=100)
	#echo "3000" > /proc/sys/vm/dirty_expire_centisecs #(default=200)
	#echo "1000" > /proc/sys/vm/dirty_writeback_centisecs #(default=500)
	echo "20" > /proc/sys/vm/dirty_ratio
	echo "5" > /proc/sys/vm/dirty_background_ratio
	echo "1" > /proc/sys/vm/oom_kill_allocating_task
	echo "4096" > /proc/sys/vm/min_free_kbytes
	echo "0" > /proc/sys/vm/panic_on_oom

# Network tweaks
	#echo "1" > /proc/sys/net/ipv4/tcp_tw_reuse #(default=0)
	#echo "1" > /proc/sys/net/ipv4/tcp_sack #(default=1)
	#echo "1" > /proc/sys/net/ipv4/tcp_tw_recycle #(default=0)
	#echo "1" > /proc/sys/net/ipv4/tcp_window_scaling #(default=1)
	#echo "5" > /proc/sys/net/ipv4/tcp_keepalive_probes #(default=9)
	#echo "30" > /proc/sys/net/ipv4/tcp_keepalive_intvl #(default=75)
	#echo "30" > /proc/sys/net/ipv4/tcp_fin_timeout #(default=60)

# Increase readahead buffers on MMC devices
	echo "512" > /sys/block/mmcblk0/bdi/read_ahead_kb
	echo "512" > /sys/block/mmcblk1/bdi/read_ahead_kb

# Execute /system/etc/init.d scripts on boot
	#chown root -R /system/etc/init.d
	#chgrp 2000 -R /system/etc/init.d
	#chmod 755 -R /system/etc/init.d
	/system/xbin/busybox run-parts /system/etc/init.d
;;
esac

# End of the init.post_boot.sh script

